package com.eactive.eai.agent.jms;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.util.Logger;
import com.eactive.eai.flowcontrol.jms.QueueMonitorManager;
import com.eactive.eai.flowcontrol.jms.QueueMonitorVO;

public class RemoveQueueMonitorCommand extends Command {
	private static final long serialVersionUID = 1L;

	public RemoveQueueMonitorCommand(String name) {
		super(name);
	}

	public RemoveQueueMonitorCommand() {
		super("RemoveQueueMonitorCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof QueueMonitorVO)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		QueueMonitorVO vo = (QueueMonitorVO) args;
		try {
			// 삭제시에는 인스턴스 정보가 변경될 수 있으므로 인스턴스정보를 확인하지 않음
			QueueMonitorManager manager = QueueMonitorManager.getInstance();
			manager.removeQueueMonitor(vo.getQueueName());
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

}
